%% 1-) Ball Position Calculator
% This script does transformation for the 3D ball position to 2D robot

% Translation vector:
% position of chesboard in camera reference system
Tc_ext = [ 17.929188 	 -0.849442 	 64.715079 ];
% Rotation matrix:
Rc_ext = [ -0.042070 	 -0.998317 	 -0.039914
    -0.614786 	 0.057357 	 -0.786605
    0.787571 	 -0.008554 	 -0.616165 ];

%transformation of camera to chess board
T_cch=[Rc_ext Tc_ext'];

H0=[eye(3) [0 0 0]'];

% the position of the origin 
image_point = [81 62 1]';

%K -calibration matrix
K=[191.71462 0  80.35911
    0  191.27299 61.27650
    0    0       1        ];
% T_rch indicates the transformation robot to chess board
% x,y,z the distance of the chess board from the robots center in mm.
x=600;
y=0;
z=0;

T_rch =[1   0   0   x
    0   1   0   y
    0   0   1   z   ];
%transformation are rewritten for clarification
% camera to world
T_cw =[T_cch;0 0 0 1];
%world to camera
T_wc = inv(T_cw);
%world to robot
T_wr =[T_rch;0 0 0 1];
% robot to world
T_rw = inv(T_wr);

position=inv(K)*image_point;
l=sqrt(x^2+y^2);
%l the distance of the origin point selected in the image to the robot
%% center
Dreal=200; %diameter of the ball in mm
Dpx=29;    %pixel counter of diameter in image

%the f* constant pixel/unit (mm)
fstar = Dpx * l / Dreal;
%the position should be normalized since position(3) is not 1
position= position/norm(position);

Pc=[(fstar*Dreal/Dpx)*position;1];

inv(T_cw*T_rw)*Pc;

result= T_wr*T_wc*Pc;

result

%ans gives the position of the ball in real world in mm
% ans(1) x;ans(2) y;ans(3) z; coordinates in real world

%% 2-) Calibration for the object at Ground

%tranlastion matrix-coming from image toolbox
Tc_ext = [ 160.700069 	 27.498986 	 492.532634 ];

%rotation matrix-coming from image toolbox
Rc_ext = [ -0.009783 	 -0.999883 	 -0.011800
    -0.428525 	 0.014854 	 -0.903408
    0.903477 	 -0.003781 	 -0.428620 ];
%transformation of camera to chess board
T_cch=[Rc_ext Tc_ext'];
% K internal camera parameters-from image toolbox
K=[191.71462 0  80.35911
    0  191.27299 61.27650
    0    0       1        ];
% x,y,z the distance of the chess board from the robots center in mm.
x=550;
y=-150;
z=0;
% T_rch indicates the transformation robot to chess board
T_rch =[1   0   0   x
    0   1   0   y
    0   0   1   z   ];
%transformation are rewritten for clarification
% camera to world
T_cch1 =[T_cch;0 0 0 1];
%world to camera
T_chc = inv(T_cch1);
%world to robot
T_rch1 =[T_rch;0 0 0 1];
% robot to world
T_chr = inv(T_rch1);


T_rc=T_rch1*T_chc;
T_cr = inv(T_rc);
T_cr = T_cr(1:3,:);

ROBOT(1,:,:,:) =T_cr(1,:,:,:);
ROBOT(2,:,:,:) =T_cr(2,:,:,:);
ROBOT(3,:,:,:) =T_cr(3,:,:,:);

t_=[1 0 0
    0 1 0
    0 0 0
    0 0 1];
H= K*T_cr*t_;
Hinv=inv(H);


point = Hinv*[72 119 1]';
result= point/point(3);
result
%% 3-) Calibration for servo_top position at ground

%tranlastion m
Tc_ext = [ 100.613176 	 95.664945 	 539.117313 ];

%rotation matrix
Rc_ext = [ 0.025851 	 -0.998468 	 0.048927
    -0.364120 	 -0.054986 	 -0.929727
    0.930993 	 0.006219 	 -0.364984 ];
%transformation of camera to chess board
T_cch=[Rc_ext Tc_ext'];
% K internal camera parameters-from image toolbox
K=[191.71462 0  80.35911
    0  191.27299 61.27650
    0    0       1        ];
% x,y,z the distance of the chess board from the robots center in mm.
x=600;
y=-100;
z=0;
% T_rch indicates the transformation robot to chess board
T_rch =[1   0   0   x
    0   1   0   y
    0   0   1   z   ];
%transformation are rewritten for clarification
% camera to world
T_cch1 = [T_cch;0 0 0 1];
%world to camera
T_chc = inv(T_cch1);
%world to robot
T_rch1 = [T_rch;0 0 0 1];
% robot to world
T_chr = inv(T_rch1);


T_rc = T_rch1*T_chc;
T_cr = inv(T_rc);
T_cr = T_cr(1:3,:);

ROBOT(1,:,:,:) =T_cr(1,:,:,:);
ROBOT(2,:,:,:) =T_cr(2,:,:,:);
ROBOT(3,:,:,:) =T_cr(3,:,:,:);

t_=[1 0 0
    0 1 0
    0 0 0
    0 0 1];
H= K*T_cr*t_;
Hinv=inv(H);

point = Hinv* [19 99 1]';
result = point/point(3);
result


